Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Module Module1
	' Quellcode erstellt von Roland Berghfer
	' bonit.at Software, Kollonitschgasse 11/2
	' A-2700 Wiener Neustadt
	' Internet: www.bonit.at www.riff.at
	
	Public Declare Function ClewareInit Lib "usbaccess.dll"  Alias "_FCWInitObject@0"() As Integer
	Public Declare Function ClewareUnInit Lib "usbaccess.dll"  Alias "_FCWUnInitObject@4"(ByVal USBObject As Integer) As Integer
	Public Declare Function ClewareOpen Lib "usbaccess.dll"  Alias "_FCWOpenCleware@4"(ByVal USBObject As Integer) As Integer
	Public Declare Function ClewareClose Lib "usbaccess.dll"  Alias "_FCWCloseCleware@4"(ByVal USBObject As Integer) As Integer
    Public Declare Function ClewareGetType Lib "usbaccess.dll" Alias "_FCWGetUSBType@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Integer
    Public Declare Function ClewareStartDevice Lib "usbaccess.dll" Alias "_FCWStartDevice@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Integer
    Public Declare Function ClewareGetSerial Lib "usbaccess.dll" Alias "_FCWGetSerialNumber@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Integer
    Public Declare Function ClewareGetVersion Lib "usbaccess.dll" Alias "_FCWGetVersion@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Integer
    Public Declare Function ClewareRecover Lib "usbaccess.dll" Alias "_FCWRecover@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Integer
    Public Declare Function ClewareReset Lib "usbaccess.dll" Alias "_FCWResetDevice@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Integer
	Public Declare Function ClewareGetDLLVersion Lib "usbaccess.dll"  Alias "_FCWGetDLLVersion@0"() As Integer
    Public Declare Function ClewareTemp Lib "usbaccess.dll" Alias "_FCWDGetTemperature@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Double
    Public Declare Function ClewareHumidity Lib "usbaccess.dll" Alias "_FCWDGetHumidity@8" (ByVal USBObject As Integer, ByVal deviceNo As Integer) As Double
    Public Declare Function ClewareSetSwitch Lib "usbaccess.dll" Alias "_FCWSetSwitch@16" (ByVal USBObject As Integer, ByVal deviceNo As Integer, ByVal Switch_ID As Integer, ByVal onoff As Short) As Short
    Public Declare Function ClewareGetSwitch Lib "usbaccess.dll" Alias "_FCWGetSwitch@12" (ByVal USBObject As Integer, ByVal deviceNo As Integer, ByVal SWITCH_IDs As Integer) As Short
	
	Public USBObject As Integer
	Public DeviceCount As Short
	Public DeviceType As Short
	Public DeviceTypeString As String
	Public SelectedSensor As Integer
	
	'Wir arbeiten mit maximal einem 4er Switch
	Public Const SWITCH_0 As Short = 16
	Public Const SWITCH_1 As Short = 17
	Public Const SWITCH_2 As Short = 18
	Public Const SWITCH_3 As Short = 19
	
	'Typendeklaration fr die erkannten Sensoren
	Public Structure Sensorentype
		Dim Seriennummer As Integer
		Dim Version As Object
		Dim Type As Short
		Dim Typestring As String
		Dim Value As Double
		Dim Realname_Short As String
		Dim Realname_Long As String
		Dim Enabled As Boolean
	End Structure
	
	
	Public Sensoren(254) As Sensorentype
	
	'UPGRADE_WARNING: Die Anwendung wird beendet, wenn Sub Main() vollstndig ausgefhrt wurde. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="E08DDC71-66BA-424F-A612-80AF11498FF8"'
	Public Sub Main()
		Dim erg As Object
		SelectedSensor = -1
		USBObject = ClewareInit()
		DeviceCount = ClewareOpen(USBObject)
		hauptform.ShowDialog()
		'UPGRADE_WARNING: Die Standardeigenschaft des Objekts erg konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		erg = ClewareClose(USBObject)
		'UPGRADE_WARNING: Die Standardeigenschaft des Objekts erg konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		erg = ClewareUnInit(USBObject)
		End
	End Sub
	Public Sub inzwischen_sensorenlesen()
		Dim erg As Object
		'UPGRADE_WARNING: Die Standardeigenschaft des Objekts erg konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		erg = ClewareClose(USBObject)
		DeviceCount = ClewareOpen(USBObject)
		sensorenlesen()
	End Sub
	Public Sub sensorenlesen()
		Dim i As Object
		If DeviceCount > 0 Then
			For i = 0 To DeviceCount - 1
				DeviceTypeString = ""
				'UPGRADE_WARNING: Die Standardeigenschaft des Objekts i konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				DeviceType = ClewareGetType(USBObject, i)
				If DeviceType = 40 Then DeviceTypeString = "USB Switch 4"
				If DeviceType = 16 Then DeviceTypeString = "USB Temp"
				If DeviceType = 32 Then DeviceTypeString = "USB Humidity"
                If DeviceType = 8 Then DeviceTypeString = "USB Switch"
                'UPGRADE_WARNING: Die Standardeigenschaft des Objekts i konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				If DeviceType = 32 Then ClewareStartDevice(USBObject, i)
				'UPGRADE_WARNING: Die Standardeigenschaft des Objekts i konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				Sensoren(i).Enabled = True
				'UPGRADE_WARNING: Die Standardeigenschaft des Objekts i konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				Sensoren(i).Type = DeviceType
				'UPGRADE_WARNING: Die Standardeigenschaft des Objekts i konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				Sensoren(i).Typestring = DeviceTypeString
				'UPGRADE_WARNING: Die Standardeigenschaft des Objekts i konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				Sensoren(i).Seriennummer = ClewareGetSerial(USBObject, i)
				'UPGRADE_WARNING: Die Standardeigenschaft des Objekts i konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				'UPGRADE_WARNING: Die Standardeigenschaft des Objekts Sensoren().Version konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				Sensoren(i).Version = ClewareGetVersion(USBObject, i)
			Next i
		End If
	End Sub
	Public Sub SwitchOn(ByRef Sensor As Integer, ByRef device As Short)
		'Schaltet einen Switch ein
		ClewareReset(USBObject, Sensor)
		warte(2)
		Select Case device
			Case 1
				ClewareSetSwitch(USBObject, Sensor, SWITCH_0, 1)
			Case 2
				ClewareSetSwitch(USBObject, Sensor, SWITCH_1, 1)
			Case 3
				ClewareSetSwitch(USBObject, Sensor, SWITCH_2, 1)
			Case 4
				ClewareSetSwitch(USBObject, Sensor, SWITCH_3, 1)
		End Select
	End Sub
	Public Sub SwitchOff(ByRef Sensor As Integer, ByRef device As Short)
		'Schaltet einen Switch aus
		ClewareReset(USBObject, Sensor)
		warte(2)
		Select Case device
			Case 1
				ClewareSetSwitch(USBObject, Sensor, SWITCH_0, 0)
			Case 2
				ClewareSetSwitch(USBObject, Sensor, SWITCH_1, 0)
			Case 3
				ClewareSetSwitch(USBObject, Sensor, SWITCH_2, 0)
			Case 4
				ClewareSetSwitch(USBObject, Sensor, SWITCH_3, 0)
		End Select
	End Sub
	Public Function ReadTemp(ByRef Sensor As Integer) As Double
		Dim zaehler As Object
		'Hier wird die Temperatur des aktuellen Sensors ausgelesen
		'Die Funktion gibt entweder die Temperatur oder bei einem Fehler -1 zurck
		Dim temperatur As Double
        temperatur = 0
        zaehler = 0
nochmal: 
        temperatur = ClewareTemp(USBObject, Sensor)
        If temperatur = -200 Then
            ClewareReset(USBObject, Sensor)
            warte(2)
            zaehler = zaehler + 1
            If zaehler < 4 Then GoTo nochmal Else GoTo nochmal1
        End If
		ReadTemp = temperatur
		'UPGRADE_WARNING: Die Standardeigenschaft des Objekts zaehler konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		If zaehler = 4 Then ReadTemp = -1
		Exit Function
		
nochmal1: 
		ClewareRecover(USBObject, Sensor) 'Verbindung zum Gert regenieren (falls diese abbricht)
		warte(2)
        ClewareReset(USBObject, Sensor)
		warte(2)
        ReadTemp = ClewareTemp(USBObject, Sensor)
        'UPGRADE_WARNING: Die Standardeigenschaft des Objekts zaehler konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		If zaehler = 4 Then ReadTemp = -1
	End Function
	Public Function ReadHumidity(ByRef Sensor As Integer) As Double
		Dim zaehler As Object
		'Hier wird die Temperatur des aktuellen Sensors ausgelesen
		'Die Funktion gibt entweder die Temperatur oder bei einem Fehler -1 zurck
		Dim humidity As Double
        humidity = 0
        zaehler = 0
nochmal: 
        humidity = ClewareHumidity(USBObject, Sensor)
        If humidity = -200 Then
            'erg = ClewareReset(USBObject, Sensor)
            'warte 2
            'erg = ClewareStartDevice(USBObject, Sensor)
            'warte 2
            'UPGRADE_WARNING: Die Standardeigenschaft des Objekts zaehler konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
            zaehler = zaehler + 1
            'UPGRADE_WARNING: Die Standardeigenschaft des Objekts zaehler konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
            If zaehler < 4 Then GoTo nochmal Else GoTo nochmal1
        End If
		ReadHumidity = humidity
		'UPGRADE_WARNING: Die Standardeigenschaft des Objekts zaehler konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		If zaehler = 4 Then ReadHumidity = -1
		Exit Function
		
nochmal1: 
		'ClewareRecover USBObject, Sensor 'Verbindung zum Gert regenieren (falls diese abbricht)
		'warte 2
		'erg = ClewareReset(USBObject, Sensor)
		'warte 2
		'erg = ClewareStartDevice(USBObject, Sensor)
		'warte 2
        humidity = ClewareHumidity(USBObject, Sensor)
		ReadHumidity = humidity
		'UPGRADE_WARNING: Die Standardeigenschaft des Objekts zaehler konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		If zaehler = 4 Then ReadHumidity = -1
	End Function
	
	Public Sub warte(ByRef zeit As Object)
		Dim Start As Double
		Dim dauer As Double
		'UPGRADE_WARNING: Die Standardeigenschaft des Objekts zeit konnte nicht aufgelst werden. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		dauer = zeit / 3
		Start = VB.Timer() ' Anfangszeit setzen.
		Do While VB.Timer() < Start + dauer
			System.Windows.Forms.Application.DoEvents() ' Steuerung an andere Prozesse
			' abgeben.
		Loop 
	End Sub
	
	'UPGRADE_NOTE: Switch wurde aktualisiert auf Switch_Renamed. Klicken Sie hier fr weitere Informationen: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
	Public Function GetSwitch(ByRef Sensor As Integer, ByRef Switch_Renamed As Integer) As Short
		Dim switch1 As Integer
		switch1 = 15 + Switch_Renamed
		GetSwitch = ClewareGetSwitch(USBObject, Sensor, switch1)
	End Function
End Module